Index: trunk/zoo-project/zoo-kernel/request_parser.c
===================================================================
--- trunk/zoo-project/zoo-kernel/request_parser.c	(revision 639)
+++ trunk/zoo-project/zoo-kernel/request_parser.c	(revision 640)
@@ -25,4 +25,7 @@
 #include "request_parser.h"
 #include "service_internal.h"
+#include "server_internal.h"
+#include "response_print.h"
+#include "caching.h"
 
 /**
@@ -127,4 +130,54 @@
     }
   return 0;
+}
+
+/**
+ * Make sure that each value encoded in base64 in a maps is decoded.
+ *
+ * @param in the maps containing the values
+ * @see readBase64
+ */
+void ensureDecodedBase64(maps **in){
+  maps* cursor=*in;
+  while(cursor!=NULL){
+    map *tmp=getMap(cursor->content,"encoding");
+    if(tmp!=NULL && strncasecmp(tmp->value,"base64",6)==0){
+      tmp=getMap(cursor->content,"value");
+      readBase64(&tmp);
+      addToMap(cursor->content,"base64_value",tmp->value);
+      int size=0;
+      char *s=strdup(tmp->value);
+      free(tmp->value);
+      tmp->value=base64d(s,strlen(s),&size);
+      free(s);
+      char sizes[1024];
+      sprintf(sizes,"%d",size);
+      addToMap(cursor->content,"size",sizes);
+    }
+    map* length=getMap(cursor->content,"length");
+    if(length!=NULL){
+      int len=atoi(length->value);
+      for(int i=1;i<len;i++){
+	tmp=getMapArray(cursor->content,"encoding",i);
+	if(tmp!=NULL && strncasecmp(tmp->value,"base64",6)==0){
+	  char key[17];
+	  sprintf(key,"base64_value_%d",i);
+	  tmp=getMapArray(cursor->content,"value",i);
+	  readBase64(&tmp);
+	  addToMap(cursor->content,key,tmp->value);
+	  int size=0;
+	  char *s=strdup(tmp->value);
+	  free(tmp->value);
+	  tmp->value=base64d(s,strlen(s),&size);
+	  free(s);
+	  char sizes[1024];
+	  sprintf(sizes,"%d",size);
+	  sprintf(key,"size_%d",i);
+	  addToMap(cursor->content,key,sizes);
+	}
+      }
+    }
+    cursor=cursor->next;
+  }
 }
 
@@ -1448,2 +1501,118 @@
   return 1;
 }
+
+
+/**
+ * Verify if a parameter value is valid.
+ * 
+ * @param request the request map
+ * @param res the error map potentially generated
+ * @param toCheck the parameter to use
+ * @param avalues the acceptable values (or null if testing only for presence)
+ * @param mandatory verify the presence of the parameter if mandatory > 0 
+ */
+void checkValidValue(map* request,map** res,const char* toCheck,const char** avalues,int mandatory){
+  map* lres=*res;
+  map* r_inputs = getMap (request,toCheck);
+  if (r_inputs == NULL){
+    if(mandatory>0){
+      char *replace=_("Mandatory parameter <%s> was not specified");
+      char *message=(char*)malloc((strlen(replace)+strlen(toCheck)+1)*sizeof(char));
+      sprintf(message,replace,toCheck);
+      if(lres==NULL){
+	lres=createMap("code","MissingParameterValue");
+	addToMap(lres,"text",message);
+	addToMap(lres,"locator",toCheck);       
+      }else{
+	int length=1;
+	map* len=getMap(lres,"length");
+	if(len!=NULL){
+	  length=atoi(len->value);
+	}
+	setMapArray(lres,"text",length,message);
+	setMapArray(lres,"locator",length,toCheck);
+	setMapArray(lres,"code",length,"MissingParameter");
+      }
+      free(message);
+    }
+  }else{
+    if(avalues==NULL)
+      return;
+    int nb=0;
+    int hasValidValue=-1;
+    if(strncasecmp(toCheck,"Accept",6)==0){
+      char *tmp=zStrdup(r_inputs->value);
+      char *pToken,*saveptr;
+      pToken=strtok_r(tmp,",",&saveptr);
+      while(pToken!=NULL){
+	while(avalues[nb]!=NULL){
+	  if(strcasecmp(avalues[nb],pToken)==0){
+	    hasValidValue=1;
+	    break;
+	  }
+	  nb++;
+	}
+	pToken=strtok_r(NULL,",",&saveptr);
+      }
+      free(tmp);
+    }else{
+      while(avalues[nb]!=NULL){
+	if(strcasecmp(avalues[nb],r_inputs->value)==0){
+	  hasValidValue=1;
+	  break;
+	}
+	nb++;
+      }
+    }
+    if(hasValidValue<0){
+      char *replace=_("The value <%s> was not recognized, %s %s the only acceptable value.");
+      nb=0;
+      char *vvalues=NULL;
+      char* num=_("is");
+      while(avalues[nb]!=NULL){
+	char *tvalues;
+	if(vvalues==NULL){
+	  vvalues=(char*)malloc((strlen(avalues[nb])+3)*sizeof(char));
+	  sprintf(vvalues,"%s",avalues[nb]);
+	}
+	else{
+	  tvalues=zStrdup(vvalues);
+	  vvalues=(char*)realloc(vvalues,(strlen(tvalues)+strlen(avalues[nb])+3)*sizeof(char));
+	  sprintf(vvalues,"%s, %s",tvalues,avalues[nb]);
+	  free(tvalues);
+	  num=_("are");
+	}
+	nb++;
+      }
+      char *message=(char*)malloc((strlen(replace)+strlen(num)+strlen(vvalues)+strlen(toCheck)+1)*sizeof(char));
+      sprintf(message,replace,toCheck,vvalues,num);
+      const char *code="VersionNegotiationFailed";
+      code="InvalidParameterValue";
+      const char *locator=toCheck;
+      if( strncasecmp(toCheck,"version",7)==0 ||
+	  strncasecmp(toCheck,"AcceptVersions",14)==0 )
+	code="VersionNegotiationFailed";
+      if( strncasecmp(toCheck,"request",7)==0){
+	code="OperationNotSupported";
+	locator=r_inputs->value;
+      }
+      if(lres==NULL){
+	lres=createMap("code","InvalidParameterValue");
+	addToMap(lres,"text",message);
+	addToMap(lres,"locator",locator);       
+      }else{
+	int length=1;
+	map* len=getMap(lres,"length");
+	if(len!=NULL){
+	  length=atoi(len->value);
+	}
+	setMapArray(lres,"text",length,message);
+	setMapArray(lres,"locator",length,locator);
+	setMapArray(lres,"code",length,"InvalidParameterValue");
+      }
+    }
+  }
+  if(lres!=NULL){
+    *res=lres;
+  }
+}
Index: trunk/zoo-project/zoo-kernel/request_parser.h
===================================================================
--- trunk/zoo-project/zoo-kernel/request_parser.h	(revision 639)
+++ trunk/zoo-project/zoo-kernel/request_parser.h	(revision 640)
@@ -23,6 +23,6 @@
  */
 
-#ifndef SERVICE_PARSER_H
-#define SERVICE_PARSER_H 1
+#ifndef ZOO_REQUEST_PARSER_H
+#define ZOO_REQUEST_PARSER_H 1
 
 #pragma once 
@@ -39,4 +39,5 @@
   xmlXPathObjectPtr extractFromDoc (xmlDocPtr, const char *);
   int appendMapsToMaps (maps*, maps*, maps*, elements*);
+  void ensureDecodedBase64(maps**);
   int kvpParseInputs(maps**,service*,map*,maps**,HINTERNET*);
   int kvpParseOutputs(maps**,map *,maps**);
@@ -45,4 +46,5 @@
   int xmlParseRequest(maps**,const char*,map**,service*,maps**,maps**,HINTERNET*);
   int parseRequest(maps**,map**,service*,maps**,maps**,HINTERNET*);
+  void checkValidValue(map*,map**,const char*,const char**,int);
   int validateRequest(maps**,service*,map*,maps**,maps**,HINTERNET*);
 
Index: trunk/zoo-project/zoo-kernel/service.h
===================================================================
--- trunk/zoo-project/zoo-kernel/service.h	(revision 639)
+++ trunk/zoo-project/zoo-kernel/service.h	(revision 640)
@@ -144,5 +144,5 @@
  * The memory size to create an elements
  */
-#define ELEMENTS_SIZE (sizeof(char*)+(((2*sizeof(char*))+sizeof(maps*))*2)+sizeof(char*)+(((2*sizeof(char*))+sizeof(iotype*))*2)+sizeof(elements*))
+#define ELEMENTS_SIZE (sizeof(char*)+(((2*sizeof(char*))+sizeof(maps*))*2)+sizeof(char*)+(((2*sizeof(char*))+sizeof(iotype*))*2)+(2*sizeof(elements*)))
 /**
  * The memory size to create a map
@@ -206,248 +206,5 @@
     struct maps* next; //!< the pointer to the next maps if any or NULL
   } maps;
-
-  /**
-   * Dump a map on stderr
-   *
-   * @param t the map to dump
-   */
-  static void _dumpMap(map* t){
-    if(t!=NULL){
-      fprintf(stderr,"%s: %s\n",t->name,t->value);
-      fflush(stderr);
-	}else{
-      fprintf(stderr,"NULL\n");
-      fflush(stderr);
-    }
-  }
-
-  /**
-   * Dump a map on stderr, see _dumpMap()
-   *
-   * @param t the map to dump
-   */
-  static void dumpMap(map* t){
-    map* tmp=t;
-    while(tmp!=NULL){
-      _dumpMap(tmp);
-      tmp=tmp->next;
-    }
-  }
-
-  /**
-   * Dump a map to a file
-   *
-   * @param t the map to dump to file
-   * @param file the file to store the map
-   */
-  static void dumpMapToFile(map* t,FILE* file){
-    map* tmp=t;
-    while(tmp!=NULL){
-#ifdef DEBUG
-      fprintf(stderr,"%s = %s\n",tmp->name,tmp->value);
-#endif
-      fprintf(file,"%s = %s\n",tmp->name,tmp->value);
-      tmp=tmp->next;
-    }
-  }
   
-  /**
-   * Dump a maps on stderr, see dumpMap().
-   *
-   * @param m the map to dump
-   */
-  static void dumpMaps(maps* m){
-    maps* tmp=m;
-    while(tmp!=NULL){
-      fprintf(stderr,"MAP => [%s] \n",tmp->name);
-      dumpMap(tmp->content);
-      tmp=tmp->next;
-    }
-  }
-
-  /**
-   * Dump a maps to a file, see dumpMapToFile().
-   *
-   * @param m the map to dump
-   * @param file_path the full path to the file name to store the map
-   */
-  static void dumpMapsToFile(maps* m,char* file_path){
-    FILE* file=fopen(file_path,"w");
-    maps* tmp=m;
-    if(tmp!=NULL){
-      fprintf(file,"[%s]\n",tmp->name);
-      dumpMapToFile(tmp->content,file);
-      fflush(file);
-    }
-    fclose(file);
-  }
-  
-  /**
-   * Create a new map
-   *
-   * @param name the key to add to the map
-   * @param value the corresponding value to add to the map
-   * @return the allocated map
-   */
-  static map* createMap(const char* name,const char* value){
-    map* tmp=(map *)malloc(MAP_SIZE);
-    tmp->name=zStrdup(name);
-    tmp->value=zStrdup(value);
-    tmp->next=NULL;
-    return tmp;
-  }
-
-  /**
-   * Count number of map in a map
-   *
-   * @param m the maps to count
-   * @return number of map in a map
-   */
-  static int count(map* m){
-    map* tmp=m;
-    int c=0;
-    while(tmp!=NULL){
-      c++;
-      tmp=tmp->next;
-    }
-    return c;
-  }
-    
-  /**
-   * Verify if a key exist in a map
-   *
-   * @param m the map to search for the key
-   * @param key the key to search in the map
-   * @return true if the key wwas found, false in other case
-   */
-  static bool hasKey(map* m,const char *key){
-    map* tmp=m;
-    while(tmp!=NULL){
-      if(strcasecmp(tmp->name,key)==0)
-	return true;
-      tmp=tmp->next;
-    }
-#ifdef DEBUG_MAP
-    fprintf(stderr,"NOT FOUND \n");
-#endif
-    return false;
-  }
-
-  /**
-   * Access a specific maps
-   *
-   * @param m the maps to search for the key
-   * @param key the key to search in the maps
-   * @return a pointer on the maps found or NULL if not found
-   */
-  static maps* getMaps(maps* m,const char *key){
-    maps* tmp=m;
-    while(tmp!=NULL){
-      if(strcasecmp(tmp->name,key)==0){
-	return tmp;
-      }
-      tmp=tmp->next;
-    }
-    return NULL;
-  }
-
-  /**
-   * Access a specific map
-   *
-   * @param m the map to search for the key
-   * @param key the key to search in the map
-   * @return a pointer on the map found or NULL if not found
-   */
-  static map* getMap(map* m,const char *key){
-    map* tmp=m;
-    while(tmp!=NULL){
-      if(strcasecmp(tmp->name,key)==0){
-	return tmp;
-      }
-      tmp=tmp->next;
-    }
-    return NULL;
-  }
-
-
-  /**
-   * Access the last map
-   *
-   * @param m the map to search for the lastest map
-   * @return a pointer on the lastest map found or NULL if not found
-   */
-  static map* getLastMap(map* m){
-    map* tmp=m;
-    while(tmp!=NULL){
-      if(tmp->next==NULL){
-	return tmp;
-      }
-      tmp=tmp->next;
-    }
-    return NULL;
-  }
-
-  /**
-   * Access a specific map from a maps
-   *
-   * @param m the maps to search for the key
-   * @param key the key to search in the maps
-   * @param subkey the key to search in the map (found for the key, if any)
-   * @return a pointer on the map found or NULL if not found
-   */
-  static map* getMapFromMaps(maps* m,const char* key,const char* subkey){
-    maps* _tmpm=getMaps(m,key);
-    if(_tmpm!=NULL){
-      map* _ztmpm=getMap(_tmpm->content,subkey);
-      return _ztmpm;
-    }
-    else return NULL;
-  }
-
-  /**
-   * Free allocated memory of a map.
-   * Require to call free on mo after calling this function.
-   *
-   * @param mo the map to free
-   */
-  static void freeMap(map** mo){
-    map* _cursor=*mo;
-    if(_cursor!=NULL){
-#ifdef DEBUG
-      fprintf(stderr,"freeMap\n");
-#endif
-      free(_cursor->name);
-      free(_cursor->value);
-      if(_cursor->next!=NULL){
-	freeMap(&_cursor->next);
-	free(_cursor->next);
-      }
-    }
-  }
-
-  /**
-   * Free allocated memory of a maps.
-   * Require to call free on mo after calling this function.
-   *
-   * @param mo the maps to free
-   */
-  static void freeMaps(maps** mo){
-    maps* _cursor=*mo;
-    if(_cursor && _cursor!=NULL){
-#ifdef DEBUG
-      fprintf(stderr,"freeMaps\n");
-#endif
-      free(_cursor->name);
-      if(_cursor->content!=NULL){
-      	freeMap(&_cursor->content);
-      	free(_cursor->content);
-      }
-      if(_cursor->next!=NULL){
-	freeMaps(&_cursor->next);
-	free(_cursor->next);
-      }
-    }
-  }
-
   /**
    * Not named linked list
@@ -472,4 +229,5 @@
     struct iotype* defaults; //!< the default iotype 
     struct iotype* supported; //!< the supported iotype 
+    struct elements* child; //!< the pointer to the children element if any (or NULL)
     struct elements* next; //!< the pointer to the next element if any (or NULL)
   } elements;
